import { useEffect, useState } from 'react';
import { getDisplayImage, getDisplayTitle } from '../utils';
import { useChatContext } from '../../../context';
export var useChannelPreviewInfo = function (props) {
    var channel = props.channel, overrideImage = props.overrideImage, overrideTitle = props.overrideTitle;
    var client = useChatContext('useChannelPreviewInfo').client;
    var _a = useState(function () { return overrideTitle || getDisplayTitle(channel, client.user); }), displayTitle = _a[0], setDisplayTitle = _a[1];
    var _b = useState(function () { return overrideImage || getDisplayImage(channel, client.user); }), displayImage = _b[0], setDisplayImage = _b[1];
    useEffect(function () {
        if (overrideTitle && overrideImage)
            return;
        var updateTitles = function () {
            if (!overrideTitle)
                setDisplayTitle(getDisplayTitle(channel, client.user));
            if (!overrideImage)
                setDisplayImage(getDisplayImage(channel, client.user));
        };
        updateTitles();
        client.on('user.updated', updateTitles);
        return function () {
            client.off('user.updated', updateTitles);
        };
    }, [channel, channel.data, client, overrideImage, overrideTitle]);
    return {
        displayImage: overrideImage || displayImage,
        displayTitle: overrideTitle || displayTitle,
    };
};
